'****************************************************************************
' HELPMNGR.BAS - A QuickBASIC environment add-in module. This module will
'                replace HelpManager in the editing environment during
'                your program development. Calling syntax is identical to
'                the assembly language version.
'                This module requires HELPMNG$.OBJ to be loaded in a Quick
'                library.
'
' (C) Copyright 1991 by Sequential Software Inc. All rights reserved.
'
' Be sure to unload this module before compiling and linking your program.
' See the accompaning documentation for further information.
'****************************************************************************

DEFINT A-Z

'This DECLARE statement is for use by this module only.

DECLARE FUNCTION HelpASM (File$, Scrn, ULRow, ULCol, Snow, Display, ColorTable$, SEG Element)

'This DECLARE statement is the replacement routine.

DECLARE FUNCTION HelpManager% (File$, Scrn%, ULRow%, ULCol%, Snow%, Display%, ColorTable$)

' This function returns the following values:
'       0 - Normal exit
'       1 - File handling error
'       2 - Memory allocation error (not enough far memory)
'       3 - Not in a text mode
'       4 - Screen too large for current display mode
'       5 - Invalid Help file (file is not a HELPGEN file)
'       6 - Other error (invalid screen requested, etc.)


'
' This function replaces HelpManager while in the environment.
'
FUNCTION HelpManager (File$, Scrn, ULRow, ULCol, Snow, Display, ColorTable$)

  
' Since assembly routines cannot allocate memory while in the QB environment,
' we must allocate memory for it. Assuming a maximum size file, we'll
' allocate 17216 bytes for HelpASM.
' (underlying screen: 8096 + crunched screen: 8096 + hyperinfo: 1024)                

   IF FRE(-1) > 17216 THEN                  'Check for enough far memory
      REDIM Buffer(1 TO 8608)
      HelpManager = HelpASM(File$, Scrn, ULRow, ULCol, Snow, Display, ColorTable$, Buffer(1))
   ELSE
      HelpManger = 2                         'Wasn't enough far memory
   END IF

END FUNCTION
